unit MainForm;

{
       WEB- 1 7.7.
  :  .
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Wininet, StdCtrls, ComCtrls, Sockets, OleCtrls, SHDocVw,
  ExtCtrls, Buttons, UnitINI, AppServerClass, ImgList, ToolWin;

type
  TForm2 = class(TForm)
    Panel3: TPanel;
    Memo1: TMemo;
    Panel2: TPanel;
    Memo2: TMemo;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    ToolButtonExit: TToolButton;
    ToolButtonTestScript: TToolButton;
    ToolButtonExecute: TToolButton;
    ImageList1: TImageList;
    StaticText1: TStaticText;
    EditURL: TEdit;
    Splitter1: TSplitter;
    StatusBar1: TStatusBar;
    ToolButtonEditINI: TToolButton;
    ToolButtonRefresh: TToolButton;
    ToolButtonTradeTest: TToolButton;
    EditURLPortal: TEdit;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    EditTempPortal: TEdit;
    StaticText4: TStaticText;
    EditUser: TEdit;
    StaticText5: TStaticText;
    EditCode: TEdit;
    StaticText6: TStaticText;
    EditPassword: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure ToolButtonTestScriptClick(Sender: TObject);
    procedure ToolButtonExecuteClick(Sender: TObject);
    procedure ToolButtonExitClick(Sender: TObject);
    procedure ToolButtonEditINIClick(Sender: TObject);
    procedure ToolButtonTradeTestClick(Sender: TObject);
    procedure EditURLPortalChange(Sender: TObject);
    procedure EditTempPortalChange(Sender: TObject);
    procedure EditUserChange(Sender: TObject);
  private
    { Private declarations }
    procedure RefreshOptions();
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.RefreshOptions();
Var
  Url: String;
begin
  Url := ReadIni('MAIN', 'URLWS1C', 'http://localhost/cgi-bin/ws1c.exe/');
  EditURL.Text := Url + ReadIni('MAIN', 'USERNAME', 'dev');
  EditUser.Text := ReadIni('MAIN', 'USERNAME', 'dev');
  EditTempPortal.Text := ReadIni('PORTAL', 'Temp', 'C:\Inetpub\wwwroot\Trade\');
  EditURLPortal.Text := ReadIni('PORTAL', 'URL', 'http://localhost/Trade/');
  //  :
  EditCode.Text := '208';
  EditPassword.Text := '123';
end;

procedure TForm2.EditTempPortalChange(Sender: TObject);
begin
  WriteIni('PORTAL', 'Temp', EditTempPortal.Text);
end;

procedure TForm2.EditURLPortalChange(Sender: TObject);
begin
  WriteIni('PORTAL', 'URL', EditURLPortal.Text);
end;

procedure TForm2.EditUserChange(Sender: TObject);
begin
  WriteIni('MAIN', 'USERNAME', EditUser.Text);
end;

procedure TForm2.FormActivate(Sender: TObject);
begin
  RefreshOptions();
end;

//  
procedure TForm2.ToolButtonExitClick(Sender: TObject);
begin
  Close;
end;

//  INI-
procedure TForm2.ToolButtonEditINIClick(Sender: TObject);
begin
  EditINI(Self.Handle);
end;

//  
procedure TForm2.ToolButtonTestScriptClick(Sender: TObject);
begin
  Memo2.Lines.Clear;
  Memo2.Lines.Add('<%');
  Memo2.Lines.Add('("'+EditCode.Text+'", "'+EditPassword.Text+'");');
  Memo2.Lines.Add('("   WS1C  !");');
  Memo2.Lines.Add('("   WS1C  !",""," WS1C");');
  Memo2.Lines.Add('("C:\Temp\");');  
  Memo2.Lines.Add('%>');
end;

//  
procedure TForm2.ToolButtonExecuteClick(Sender: TObject);
Var
  AppServer: TAppServer;
  User, TempPortal, URLPortal, Script : String;
begin
  Memo1.Clear;
  AppServer := TAppServer.Create;
  try
    User := EditUser.Text;
    TempPortal := EditTempPortal.Text;
    URLPortal := EditURLPortal.Text;
    Script := Memo2.Lines.Text;
    Memo1.Lines.Add(AppServer.Execute(URLPortal, TempPortal, User, Script));
  finally
    AppServer.Free;
  end;
end;

//    " " (  1 7.7. Web- 2.0)
procedure TForm2.ToolButtonTradeTestClick(Sender: TObject);
Var
  PostData:TStringList;
  URL: String;
  AppServer: TAppServer;
begin
  Memo1.Clear;
  AppServer := TAppServer.Create;
  PostData  := TStringList.Create;
  try
    PostData.Clear;
    // PostData.Add('Code=208');
    // PostData.Add('Password=123');
    //    GET:
    //  
    URL := 'http://localhost/Trade/default.asp?Code='+EditCode.Text+'&Password='+EditPassword.Text;
    Memo1.Lines.Add(AppServer.OpenURL(URL, PostData));
  finally
    AppServer.Free;
    PostData.Free;
  end;

end;

end.
