//(c) Sergey Krotkich, Kharkov, Ukraine, 2009
//mailto: skrotkich@ukr.net
// :
//    
// -    ASP-;
// -  ASP-;
// -  .

unit Unit1C;

interface

uses
  Windows, SysUtils, Classes, Forms, IdHTTP, UnitINI, ImgList, ToolWin;

type
  TUnit1C = class(TObject)
  private
    { Private declarations }
    IdHTTP: TIdHTTP;
    UserName: String;
    URLWS1C: String;
    v7Script: String;
    Data1C: String;
    function UrlEncode(Str: string): string;
    function fAnsiPos(const Substr, S: string; FromPos: integer): Integer;
  public
    { Publick declarations }
    constructor Create();
    Procedure SetScript(Script: String);
    Function Execute(): Boolean;
    Function GetData(): String;
  end;

implementation
Uses
  MainForm;

{
http://delphiworld.narod.ru/base/encode_url.html
**** UBPFD *********** by delphibase.endimus.com ****
>> URL  

    URL    
 http . ..  -    
'_'  ,    '+',    
   '%'    .

: Windows
:       Dimka Maslov, mainbox@endimus.ru, ICQ:148442121, -
Copyright:   Dimka Maslov
:        27  2002 .
***************************************************** }

function TUnit1C.UrlEncode(Str: string): string;

  function CharToHex(Ch: Char): Integer;
  asm
    and eax, 0FFh
    mov ah, al
    shr al, 4
    and ah, 00fh
    cmp al, 00ah
    jl @@10
    sub al, 00ah
    add al, 041h
    jmp @@20
@@10:
    add al, 030h
@@20:
    cmp ah, 00ah
    jl @@30
    sub ah, 00ah
    add ah, 041h
    jmp @@40
@@30:
    add ah, 030h
@@40:
    shl eax, 8
    mov al, '%'
  end;

var
  i, Len: Integer;
  Ch: Char;
  N: Integer;
  P: PChar;
begin
  Result := '';
  Len := Length(Str);
  P := PChar(@N);
  for i := 1 to Len do
  begin
    Ch := Str[i];
    if Ch in ['0'..'9', 'A'..'Z', 'a'..'z', '_'] then
      Result := Result + Ch
    else
    begin
      if Ch = ' ' then
        Result := Result + '+'
      else
      begin
        N := CharToHex(Ch);
        Result := Result + P;
      end;
    end;
  end;
end;

{ **** UBPFD *********** by delphibase.endimus.com ****
>>        ( )

 
Substr - , S - , fromPos -    
   ,  0
 -   ansiStrPos

: SysUtils
:       Romkin, romkin@pochtamt.ru, 
Copyright:   Romkin
:        18  2002 .
***************************************************** }

function TUnit1C.fAnsiPos(const Substr, S: string; FromPos: integer): Integer;
var
  P: PChar;
begin
  Result := 0;
  P := AnsiStrPos(PChar(S) + fromPos - 1, PChar(SubStr));
  if P <> nil then
    Result := Integer(P) - Integer(PChar(S)) + 1;
end;

constructor TUnit1C.Create();
begin
  UserName  := ReadIni('MAIN', 'USERNAME', 'dev');
  URLWS1C   := ReadIni('MAIN', 'URLWS1C', 'http://localhost/cgi-bin/ws1c.exe/');
  URLWS1C   := URLWS1C + UserName;
  v7Script := '';
end;

Procedure TUnit1C.SetScript(Script: String);
begin
  v7Script :=  UrlEncode(Trim(Script));
end;

Function TUnit1C.Execute() : Boolean;
var
  s, URLASP: String;
  i, j: Integer;
  Post:TStringList;
begin
  Result := False;
  if Length(v7Script) = 0 then
    Exit;

  Post := TStringList.Create;
  Application.ProcessMessages;
  Post.Add('v7Script=' + v7Script);
  Post.Add('USER=' + UserName);

  //    
  try
    s := IdHTTP.Post(URLWS1C, Post);
    i := fAnsiPos('http:', s, 1);
    if i > 0 then Begin
      j := fAnsiPos('<', s, i);
      URLASP := Copy(s, i, j - i);
      Post.Clear;
      //   ASP-
      Data1C := IdHTTP.Post(URLASP, Post);
      Result := True;
    End;
  except
    Post.Free;
  end;
end;

Function TUnit1C.GetData(): String;
Begin
  Result := Data1C;
End;

end.
