unit WebModule;

{
  CGI-.
     :   
     .

  :  .
}

interface

uses
  Windows, SysUtils, Classes, HTTPProd, CGIHTTP, Dialogs, UnitINI,
  IdBaseComponent, IdCoder, IdCoder3to4, IdCoderMIME, OtherFunctions, HTTPApp;

type
  TWebModule1 = class(TWebModule)
    PageProducer1: TPageProducer;
    procedure PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: string; TagParams: TStrings; var ReplaceText: string);
    procedure WebModule1someinfoAction(Sender: TObject; Request: TWebRequest;
      Response: TWebResponse; var Handled: Boolean);
    procedure WebModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModule1: TWebModule1;

implementation

{$R *.dfm}

//  
procedure TWebModule1.PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
  const TagString: string; TagParams: TStrings; var ReplaceText: string);
Var
  Value: String;
begin
  ReplaceText := '';
  if (TagString = 'v7Script') then Begin
    Value := Trim(Request.ContentFields.Values[TagString]);
    if Length(Value) > 0 then
      ReplaceText := UrlDecode(Request.ContentFields.Values[TagString]);
    Log(TagString + '=' + ReplaceText + ';');
  End;
End;

// ASP- .     .
procedure TWebModule1.WebModule1someinfoAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  ContFileName, ASPFileName: String;
  fcontent: TextFile;
  content, TempPORTAL, URLPORTAL, URLredir, UserName: String;
  i: Integer;
begin
  content := PageProducer1.Content;

  //  .
  UserName := UrlDecode(Request.ContentFields.Values['USER']);

  // C:\Inetpub\wwwroot\Trade\
  TempPORTAL := UrlDecode(Request.ContentFields.Values['TEMPPORTAL']);
  if Length(TempPORTAL) = 0 then
    //  
    TempPORTAL :=ReadIni('PORTAL', 'Temp', 'C:\Inetpub\wwwroot\Trade\');

  // http://localhost/Trade/
  URLPORTAL := UrlDecode(Request.ContentFields.Values['URLPORTAL']);
  if Length(URLPORTAL) = 0 then
    //  
    URLPORTAL := ReadIni('PORTAL', 'URL', 'http://localhost/Trade/');

  if Length(UserName) > 0 then
    ASPFileName := 'Task_'+UserName+'.asp'
  Else
    ASPFileName := 'Task_Nil.asp';
  //  content   Content
  ContFileName := TempPORTAL + ASPFileName;
  If FileExists(ContFileName) Then
    If NOT DeleteFile(ContFileName) Then Begin
      Log(' '+IntToStr(GetLastError)+'    '+ContFileName);
      Exit;
    End;
	i := FileCreate(ContFileName);
	if i < 0 then Begin
    Log(' '+IntToStr(GetLastError)+'    '+ContFileName);
    Exit;
  End;
	FileClose(i);
  AssignFile(fcontent, ContFileName);
  Append(fcontent);
  WriteLn(fcontent, content);
  CloseFile(fcontent);

  content:= '<html><head><title>Redirect</title>';
  content:= content + '<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">';
  URLredir:= URLPORTAL +  ASPFileName;
  content:= content + '</head><body>'+URLredir+'</body></html>';

  //   
  Response.Content:= content;
  Log(' '+URLredir);
end;

procedure TWebModule1.WebModuleCreate(Sender: TObject);
begin
  PageProducer1.HTMLFile := ExtractFilePath(ParamStr(0)) + 'Shablon\Page1.htm';
end;

end.
